<?php

class logisticsmanager_rpc_request_taobao extends logisticsmanager_rpc_abstract {

    /**
     * 获取运单号
     * @param Mix $data 发送数据
     */
    public function get_waybill_number($data) {
        $params = array(
            'cp_code' => $data['cp_code'],
            'shipping_address' => json_encode($data['shipping_address']),
            'trade_order_info_cols' => json_encode($data['trade_order_info_cols']),
        );
        $method = 'store.wlb.waybill.get';
        $writelog = array(
            'log_type' => 'other',
            'log_title' => '获取淘宝云栈面单_' . $data['cp_code'],
            'original_bn' => $data['out_biz_code'],
        );
        $callback = array();
        $result = $this->request($method, $params, $callback, $data['shop_id'], $writelog);
        if (empty($callback) && $result) {
            $result = $this->get_waybill_number_process($result, $data);
        }
        return $result;
    }

    /**
     * 获取运单处理
     * @param Array $data 返回数据
     */
    public function get_waybill_number_process($result , $params) {
        //状态
        $status = isset($result['rsp']) ? $result['rsp'] : '';
        $data = empty($result['data']) ? '' : json_decode($result['data'], true);
        $ret = $this->rpc_log($result);
        $waybillCodeArr = array();
        if ($status == 'succ' && count($data['waybill_apply_new_info']) > 0) {
            foreach ($data['waybill_apply_new_info'] as $k => $v) {
                $waybill_code = $v['waybill_code'];
                if ($waybill_code) {
                    if ($this->insertWaybillCode($waybill_code, $params)) {
                        $updata = array('status' => 'success');
                        $this->updateDeliveryLogino($params['delivery_id'], $waybill_code);
                        $waybillCodeArr[] = array(
                            'logi_no' => $waybill_code,
                            'delivery_id' => $params['delivery_id'],
                            'delivery_bn' => $params['delivery_bn'],
                        );
                        //获取物流单信息
                        $waybill = $this->getWayBill($waybill_code, $params);
                        if ($waybill) {
                            $waybillExtned = array(
                                'waybill_id' => $waybill['id'],
                                'mailno_barcode' => '',
                                'qrcode' => '',
                                'position' => $v['short_address'],
                                'position_no' => '',
                                'package_wdjc' => '',
                                'package_wd' => '',
                                'json_packet' => '',
                            );
                            //保存电子面单扩展信息
                            $this->saveWaybillExtend($waybillExtned, true);
                        }
                    }
                    else {
                        $updata = array('status' => 'fail');
                    }
                    $filter = array('log_id' => $params['out_biz_code']);
                    $this->updateWaybillLog($updata, $filter);
                }
            }
        }
        else {
            $waybillCodeArr[] = array(
                'delivery_id' => $params['delivery_id'],
                'delivery_bn' => $params['delivery_bn'],
            );
        }
        $ret['data'] = $waybillCodeArr;
        return $ret;
    }
}
