<?php
/**
* 入库单
*
* @copyright shopex.cn 2014.05.07
* @author sunjing<sunjing@shopex.cn>
*/
class middleware_wms_matrixwms_request_360buy_stockin extends middleware_wms_matrixwms_request_stockin{
    
    /**
     * 入库创建通知单参数
     * @param   array sdf
     * @return  sdf
     * @access  protected
     * @author cyyr24@sina.cn
     */
    protected  function _getStockin_create_params($sdf,$cur_page)
    {
        
        $stockin_bn = $sdf['io_bn'];
        $items_count = count($sdf['items']);
        $total_page = ceil($items_count/$this->limit);
        $sdf['item_total_num'] = $sdf['line_total_count'] = $items_count;
        
        $sdf_items = self::getItems($sdf['items'],$cur_page,$this->limit);
        $oForeign_sku = app::get('console')->model('foreign_sku');
        $branch_relationObj = &app::get('wmsmgr')->model('branch_relation');
        $branch_relation = $branch_relationObj->dump(array('sys_branch_bn'=>$sdf['branch_bn']));
        $wms_id = kernel::single('ome_branch')->getWmsId($sdf['branch_bn']);
        if ($sdf_items){
            $offset = ($cur_page-1) * $this->limit + 1;
            $items = array();

            foreach ($sdf_items as $v){
                // 获取外部商品sku
                $inventory_type = '1';
                if (isset($sdf['type_id']) && $sdf['type_id']) {

                    $inventory_type = $this->inventory_type[$sdf['type_id']] ? $this->inventory_type[$sdf['type_id']] : '1';
                }
                
                
                $items[] = array(
                    'item_code' => $oForeign_sku->get_product_outer_sku($wms_id,$v['bn'] ),
                    'item_name' => $v['name'],
                    'item_quantity' => $v['num'],
                    'item_price' => $v['price'] ? $v['price'] : '0',// TODO: 商品价格
                    'item_line_num' => $offset,// TODO: 订单商品列表中商品的行项目编号，即第n行或第n个商品
                    'trade_code' => '',//可选(若是淘宝交易订单，并且不是赠品，必须要传订单来源编号) 
                    'item_id' => $v['bn'],// 商品ID
                    'is_gift' => '0',// TODO: 判断是否为赠品0:不是1:是
                    'item_remark' => '',// TODO: 商品备注
                    'inventory_type' => $inventory_type,// TODO: 库存类型1可销售库存101类型用来定义残次品201冻结类型库存301在途库存
                );
                $offset++;
            }
        }
       
        $wms_order_code = $stockin_bn;
        $order_type = $this->__stockin_type[$sdf['io_type']] ? $this->__stockin_type[$sdf['io_type']] : 'IN_OTHER';
        $create_time = preg_match('/-|\//',$sdf['create_time']) ? $sdf['create_time'] : date("Y-m-d H:i:s",$sdf['create_time']);
        
        $wms_branch_bn = 
        $params = array(
            'uniqid' => self::uniqid(),
            'out_order_code' => $stockin_bn,
            'order_type' => $order_type,
            'created' => $create_time,
            'wms_order_code' => $wms_order_code,
            'is_finished' => $cur_page >= $total_page ? 'true' : 'false',
            'current_page' => $cur_page,// 当前批次,用于分批同步
            'total_page' => $total_page,// 总批次,用于分批同步
            'logistics_code' => '',// TODO: 快递公司（如果是汇购传递快递公司，则该项目不能为空，否则可以为空处理）
            'logistics_no' => '',// TODO: 运输公司运单号
            'remark' => $sdf['memo'],
            'line_total_count' => $sdf['line_total_count'],// TODO: 订单行项目数量
            'item_total_num' => $sdf['item_total_num'],
            'storage_code' => $sdf['storage_code'],// 库内存放点编号
            'warehouse_code'=>$branch_relation['wms_branch_bn'],
            'expect_start_time'=>date('Y-m -d H:i:s'),
            'items' => json_encode(array('item'=>$items)),
        );
        
       return $params;
    }

    /**
     * 入库单取消参数
     * @param   array sdf
     * @return  array
     * @access  protected
     * @author sunjing@shopex.cn
     */
    protected function _getStockin_cancel_params($sdf)
    {
        $stockin_bn = $sdf['io_bn'];
        $order_type = $this->__stockin_type[$sdf['io_type']] ? $this->__stockin_type[$sdf['io_type']] : 'IN_OTHER';
        $params = array(
            'out_order_code' => $sdf['out_iso_bn'],
            //'order_type' => $order_type,
        );
        return $params;
    }

    /**
    * 入库单取消
    * @access public
    * @param Array $sdf 入库单数据
    * @param String $sync 同异步类型：false(同步)、true(异步)，默认true
    * @return Array 标准输出格式
    */
    public function stockin_cancel(&$sdf,$sync=false){
        return array('rsp'=>'fail','msg'=>'接口方法不存在','msg_code'=>'w402');
    }
}