<?php
class ome_preprocess_crm{
    public $fenxiaowang = 'shopex_b2b';//分销王的店铺类型,需要检测订单类型
    private static  $__crm_gifts = array();
    
    public function process($order_id,&$msg){
        #获取crm基本配置
        $crm_cfg = app::get('crm')->getConf('crm.setting.cfg');
        #如果没有开启crm应用，程序返回
        if(empty($crm_cfg)){
            return false;
        }
        $operationLogObj = &app::get('ome')->model('operation_log');
        $Obj_preprocess = &app::get('ome')->model('order_preprocess');
        $opinfo = kernel::single('ome_func')->get_system();
        if(!$order_id){
            return false;
        }

        #检测是否开启赠品
        if($crm_cfg['gift'] != 'on'){
            $msg = '订单没有开启CRM赠品';
            $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
            return false;
        }
        $_rs = $Obj_preprocess->getList('*',array('preprocess_order_id'=>$order_id,'preprocess_status'=>'1'));
        #不为空，说明已经获取过CRM赠品
        if(!empty($_rs)){
            return true;
        }
        $orderObj = &app::get('ome')->model('orders');
        $obj_channel = app::get('channel')->model('channel');
        
        #根据订单号，找到当前订单的相关信息
        $order_info = $obj_channel->getOrderInfo($order_id);
        #获取订单明细
        $order_item_info = $obj_channel->getOrderItemInfo($order_id);
       
        #打标的状态
        $status = $order_info['abnormal_status'] | ome_preprocess_const::__HASCRMGIFT_CODE;
        
        $order_bn    = $order_info['order_bn'];#单号
        $shop_type    = $order_info['shop_type'];#店铺类型
        $shop_id       = $order_info['shop_id'];#店铺节点
        $receiver_name = $order_info['ship_name'];#收件人姓名
        $buyer_nick    = $order_info['uname'];#会员名
//        $mobile        = $order_info['ship_mobile']?$order_info['ship_mobile']:$order_info['ship_tel'];
        $mobile        = $order_info['ship_mobile'] ? $order_info['ship_mobile'] : '';
        $tel           = $order_info['ship_tel'] ? $order_info['ship_tel'] : '';
        $ship_area     = $order_info['ship_area'];
        $ship_area_arr = '';
        if ($ship_area && is_string($ship_area)) {
            $firstPos = strpos($ship_area, ':');
            $lastPos = strrpos($ship_area, ':');
            $newShipArea = substr($ship_area, $firstPos + 1, ($lastPos - $firstPos - 1));
            $ship_area_arr = explode('/', $newShipArea);
        }
        $payed = $order_info['payed'] ?  $order_info['payed'] : 0;#付款金额
        $pay_time = $order_info['paytime'] ? $order_info['paytime'] : 0;#付款时间
        $isCod = $order_info['is_cod'] == 'true' ? 1 : 0;

        #检测当前订单的来源店铺否开启赠品
        if(empty($crm_cfg['name'][$shop_id])){
           $msg = '订单的来源店铺没有开启CRM赠品';
           $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
           return false;
        }
        #如果属于分销王的店铺类型，需要检测分销王的订单类型；其他店铺类型,暂时不需要检测订单类型
        if($shop_type == $this->fenxiaowang){
            #检测分销王订单类型
            $fenxiaowang_shop_id  = null;
            foreach($crm_cfg['name'] as $_name){
                $_info = explode('===', $_name);
                if($_info[0] == $this->fenxiaowang ){
                    $fenxiaowang_shop_id = $_info[1];
                    break;
                }
            }
            #分销王的订单类型不存在
            if(empty($crm_cfg['order_type'][$fenxiaowang_shop_id])){
                $msg = '分销王店铺的订单类型没有开启CRM赠品';
                $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
                return false;
            }
        }

       #检测完毕,调用赠品接口,获取赠品规则
       $params = array(
           'buyer_nick' => $buyer_nick,
           'receiver_name'=> $receiver_name,
           'mobile' => $mobile,
           'tel' => $tel,
           'shop_id' => $shop_id,
           'order_bn' => $order_bn,
           'province' => $ship_area_arr[0],
           'city' => $ship_area_arr[1],
           'district' => $ship_area_arr[2],
           'total_amount' => $order_info['total_amount'],
           'payed' => $payed,
           'createtime' => $order_info['createtime'],
           'pay_time' => $pay_time,
           'is_cod' => $isCod,
           'items' => $order_item_info
       );
       #组成唯一键
       $_key = $shop_id.$receiver_name.$buyer_nick.$mobile;
       $key = md5($_key);
       #检测静态变量中的赠品数据
       if(isset(self::$__crm_gifts[$key])){
           $gift_rule = self::$__crm_gifts[$key];
           #检测赠品数据是否为空，如果为空，程序返回
           if(empty($gift_rule['data'])){
               $msg = '订单CRM赠品为空';
               $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
               return false;
           }
       }else{
           $obj_crm_rpc = kernel::single('crm_rpc_gift');
           #根据店铺节点、收件人、会员名、手机，获取赠品规则
           $gift_rule = $obj_crm_rpc->getGiftRule($params);
           if($gift_rule['result'] == 'succ'){
               #如果返回成功，把数据继存起来
               self::$__crm_gifts[$key] = $gift_rule;
               #如果返回成功，但是订单天生没有赠品，则程序返回
               if(empty($gift_rule['data'])){
                   $msg = '订单CRM赠品为空';
                   $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
                   return false;
               }
           }elseif($gift_rule['result'] == 'fail'){
               $msg = $gift_rule['msg'];
               #不添加赠品，继续审单发货
               if($crm_cfg['error'] == 'off' ){
                   $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
                   return false;
               }elseif($crm_cfg['error'] == 'on'){
                   #打标提醒，人工处理
                   $orderObj->update(array('abnormal_status'=>$status),array('order_id'=>$order_id));
                   $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
                   #打标与记日志完成后，程序返回
                   return false;
               }
           }
       }       
       
       #获取crm请求返回的所有gift_id
       $crm_gift_bn = array();
       $crm_gift_bn = explode(',', $gift_rule['data']['gift_bn']);

       $obj_crm_gift = app::get('crm')->model('gift');
       #根据crm请求返回的gift_id，到淘管赠品数据库中检测赠品货号是否对应
       $_gift_bn = $obj_crm_gift->getList('gift_bn',array('gift_bn'=>$crm_gift_bn));
       foreach($_gift_bn as $_bn){
           #用于检测的淘管赠品货号
           $erp_gift_bn[]  = $_bn['gift_bn'];
       } 
       #获取无法在淘管中对应的赠品货号
       $diff_bn = array_diff($crm_gift_bn, $erp_gift_bn);
       $str_bn = implode($diff_bn,',');
       #赠品不对应
       if(!empty($diff_bn)){
           $msg = 'CRM赠品'.$str_bn.'与淘管的赠品货号不对应，不能添加';
           #不添加赠品，继续审单发货
           if( $crm_cfg['error'] == 'off'){
               $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
               return false;
           }elseif( $crm_cfg['error'] == 'on'){
               #打标提醒，人工处理
               $orderObj->update(array('abnormal_status'=>$status),array('order_id'=>$order_id));
               $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
               #打标与记日志完成后，程序返回
               return false;
           }
       }
       #根据赠品货号，找到赠品对应的货品信息
       $obj_product = app::get('ome')->model('products');
       $product_info = $obj_product->getList('store,product_id,goods_id,bn,name',array('bn'=>$crm_gift_bn));
       $nostock_bn = array();//库存不足的货号
       foreach($product_info as $info){
           if($info['store'] <= 0 ){
               #把库存不足的货号临时存起来
               $nostock_bn[] = $info['bn'];
            }
       }
       
       #库存不足时的处理
       if(!empty($nostock_bn)){
            $str_nostock_bn =  implode(',',$nostock_bn);
            $msg = 'CRM赠品货号'.$str_nostock_bn.'库存不足，不能添加';
            if($crm_cfg['nostock'] == 'off'){
               $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
               return false;
            }elseif($crm_cfg['nostock'] == 'on'){
               
               #打标提醒，人工处理
               $orderObj->update(array('abnormal_status'=>$status),array('order_id'=>$order_id));
               $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
               #打标与记日志完成后，程序返回
               return false;
               
            } 
       }
       #以上验证处理完毕，开始处理相关订单流程
       $orderItemObj  = &app::get('ome')->model("order_items");
       $orderObjectObj  = &app::get('ome')->model("order_objects");


       
      kernel::database()->exec('begin');
      foreach($product_info as $info){
          $is_update = true;
              $tmp_obj = array(
                      'order_id' => $order_id,
                      'obj_type' => 'gift',
                      'shop_goods_id' => '',
                      'goods_id' => $info['goods_id'],
                      'bn' => $info['bn'],
                      'name' => $info['name'],
                      'price' => 0.00,
                      'sale_price' => 0.00,
                      'pmt_price' => 0.00,
                      'amount' => 0.00,
                      'quantity' => 1
              );
              if($orderObjectObj->save($tmp_obj)){
                      $tmp_items = array(
                              'order_id' => $order_id,
                              'obj_id' => $tmp_obj['obj_id'],
                              'shop_goods_id' => '',//暂时不要写
                              'product_id' => $info['product_id'],
                              'shop_product_id' => 0,
                              'bn' => $info['bn'],
                              'name' => $info['name'],
                              'cost' => 0.00,
                              'price' => 0.00,
                              'amount' => 0.00,
                              'sale_price'=> 0.00,
                              'pmt_price' => 0.00,
                              'nums' => 1,
                              'sendnum' => 0,
                              'item_type' => 'gift',
                      );
                      if($orderItemObj->save($tmp_items)){
                          $obj_product->chg_product_store_freeze($product_info['product_id'],1,"+");
                      }else{
                          $is_update = false;
                          kernel::database()->rollBack();
                          break;
                      }
              }else{
                  $is_update = false;
                  kernel::database()->rollBack();
                  break;
              }
              $tmp_obj = array();
       }
      if($is_update){
          $msg = '订单预处理CRM赠品完成';
          #记录CRM预处理完成状态
          $data_preprocess = array('preprocess_order_id'=>$order_id,'preprocess_type'=>'crm','preprocess_status'=>'1');
          $Obj_preprocess->save($data_preprocess);
          
          $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
          kernel::database()->commit();
          return true ;
      }else{
          kernel::database()->rollBack();

          $msg = '订单CRM赠品添加数据出错';
          $status = $order_info['abnormal_status'] | ome_preprocess_const::__HASCRMGIFT_CODE;
          #添加赠品出错的时候，继续审单发货
          if( $crm_cfg['error'] == 'off'){
              $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
              return false;
          }
          #添加赠品出错的时候，打标提醒，人工处理
          elseif( $crm_cfg['error'] == 'on'){
              $orderObj->update(array('abnormal_status'=>$status),array('order_id'=>$order_id));
              $operationLogObj->write_log('order_preprocess@ome',$order_id, $msg,time(),$opinfo);
              #打标与记日志完成后，程序返回
              return false;
          }
      }
    }
}