<?php

class wms_mdl_delivery_outerlogi extends wms_mdl_delivery{

    public function table_name($real=false)
    {
        $table_name = 'delivery';
        if($real){
            return DB_PREFIX.'wms_'.$table_name;
        }else{
            return $table_name;
        }
    }

    public function exportName(&$data)
    {
        $data['name'] = '快速发货模板'.date('Ymd');
    }

    public function io_title( $filter=null,$ioType='csv'){
        switch( $ioType ){
            case 'csv':
            default:
                $this->oSchema['csv']['main'] = array(
                    '*:发货单号' => 'delivery_bn',
                    '*:物流单号' => 'logi_no',
                    '*:重量' => 'weight',
                    //'*:外部发货单号' => 'outer_delivery_bn',
                    //'*:承接商' => 'outer_supplier',
                    //'*:实际物流费用' => 'delivery_cost_actual',
                );
        }
        $this->ioTitle[$ioType][$filter] = array_keys( $this->oSchema[$ioType]['main'] );
        return $this->ioTitle[$ioType][$filter];
    }

    public function fgetlist_csv(&$data,$filter,$offset,$exportType = 1)
    {
        $title = array();
        if ( !$data['title'] ) {
            foreach( $this->io_title() as $k => $v ){
                $title[] = $this->charset->utf2local($v);
            }
            $data['title']['delivery'] = '"'.implode('","',$title).'"';

            return true;
        }

        $filter['process'] = 'false';

        $list = $this->getList('delivery_bn',$filter,0,-1);
        if ($list) {
            $contents = array();
            foreach ($list as $l) {
                $contents = array(
                    'delivery_bn' => $l['delivery_bn']."\t",
                    'logi_no'     => '',
                    'weight'      => '',
                );
                $data['content']['delivery'][] = implode(',', $contents);
            }
        }
        return false;
    }


    public function prepared_import_csv(){
        $this->ioObj->cacheTime = time();
    }

    public function prepared_import_csv_row($row,&$title,&$tmpl,&$mark,&$newObjFlag,&$msg)
    {
        if(empty($row)) return false;

        if( substr($row[0],0,1) == '*' ){
            $this->nums = 1;
            $title = array_flip($row);

            # $mark = 'title';
            return false;
        }

        if (empty($title)) {
            $msg['error'] = "请使用正确的模板格式！";
            return false;
        }

        $delivery_bn = trim($row[$title['*:发货单号']]);
        //$outer_delivery_bn = $row[$title['*:外部发货单号']];
        //$outer_supplier = $row[$title['*:承接商']];
        $logi_no = trim($row[$title['*:物流单号']]);
        //$delivery_cost_actual = $row[$title['*:实际物流费用']];
        $weight = trim($row[$title['*:重量']]);
        if(isset($this->nums)){
            $this->nums++;
            if($this->nums > 5000){
                $msg['error'] = "导入的数据量过大，请减少到5000条以下！";
                return false;
            }
        }

        #$mark = 'contents';
        if (empty($logi_no)) {
            $msg['warning'][] = 'Line '.$this->nums.'：运单号不能都为空！';
            return false;
        }

        if (empty($delivery_bn)) {
            $msg['warning'][] = 'Line '.$this->nums.'：发货单号不能都为空！';
            return false;
        }

        # 获取第三方发货仓
        $branchList = app::get('ome')->model('branch')->getList('branch_id',array('owner'=>'2'));
        $branchIds = array();
        foreach ($branchList as $key => $value) {
            $branchIds[] = $value['branch_id'];
        }
        if (empty($branchIds)) {
            $msg['error'] = '第三方仓不存在，请新建！！！';
            return true;
        }

        # 判断发货单是否存在
        $deliModel = app::get('wms')->model('delivery');
        $delivery = $deliModel->dump(array('delivery_bn'=>$delivery_bn),'delivery_id,status,logi_id,branch_id,net_weight,ship_area');
        if (!$delivery) {
            $msg['warning'][] = 'Line '.$this->nums.'：发货单号不存在！';
            return false;
        }

        # 验证运单号是否被使用过
        $dlyCheckLib = kernel::single('wms_delivery_check');
        $logi_no_exist = $dlyCheckLib->existExpressNoBill($logi_no,$delivery['delivery_id']);
        if ($logi_no_exist) {
            $msg['warning'][] = 'Line '.$this->nums.'：运单号已被使用！';
            return false;
        }

        if ($delivery['status'] == 3) {
            $msg['warning'][] = 'Line '.$this->nums.'：发货单号【'.$delivery_bn.'】已发货！';
            return false;
        }

        if (!in_array($delivery['branch_id'], $branchIds)) {
            $msg['warning'][] = 'Line '.$this->nums.'：不是第三方仓不能发货！';
            return false;
        }

        // 库存验证
        $branch_pObj = app::get('ome')->model("branch_product");
        $delivery_items = $this->app->model('delivery_items')->getList('*',array('delivery_id'=>$delivery[0]['delivery_id']));
        foreach ($delivery_items as $key=>$value) {
            $bp = $branch_pObj->dump(array('branch_id'=>$delivery['branch_id'],'product_id'=>$value['product_id']),'store');
            if ($bp['store'] < $value['number']) {
                $msg['warning'][] = 'Line '.$this->nums.'：【'.$value['product_name'].'】商品库存不足';
                return false;
            }
        }

        $minWeight = app::get('wms')->getConf('wms.delivery.minWeight');
        if (empty($weight)) {
            $weight = $delivery['net_weight'] ? $delivery['net_weight'] : $minWeight;
        }

        $weightSet = &app::get('wms')->getConf('wms.delivery.weight');
        if (empty($weight) && $weightSet=='on'){
            $msg['warning'][] = 'Line '.$this->nums.'：请输入重量信息！';
            return false;
        }

        $maxWeight = app::get('wms')->getConf('wms.delivery.maxWeight');
        if($weight < $minWeight || $weight > $maxWeight){
            $msg['warning'][] = 'Line '.$this->nums.'：包裹重量超出系统设置范围！';
            return false;
        }

        //获取物流费用
        $wmsCommonLib = kernel::single('wms_common');

        $area = $delivery['consignee']['area'];
        $arrArea = explode(':', $area);
        $area_id = $arrArea[2];
        $delivery_cost_actual = $wmsCommonLib->getDeliveryFreight($area_id,$delivery['logi_id'],$weight);

        $opInfo = kernel::single('ome_func')->getDesktopUser();

        $sdf = array(
            'delivery_id' => $delivery['delivery_id'],
            //'outer_delivery_bn' => $outer_delivery_bn,
            //'outer_supplier' => $outer_supplier,
            'logi_no' => $logi_no,
            'delivery_cost_actual' => $delivery_cost_actual ? $delivery_cost_actual : 0,
            'weight' => $weight ? $weight : 0,
            'opInfo' => $opInfo,
            'is_super' => kernel::single('desktop_user')->is_super(),
            'user_data' => kernel::single('desktop_user')->user_data,
            //'verify' => $delivery[0]['verify'],
            //'stock_status' => $delivery[0]['stock_status'],
            //'deliv_status' => $delivery[0]['deliv_status'],
            //'expre_status' => $delivery[0]['expre_status'],
        );

        $this->import_data[] = $sdf;
        return true;
    }

    function prepared_import_csv_obj($data,$mark,$tmpl,&$msg = ''){
        return null;
    }

    public function finish_import_csv(){

        $oQueue = app::get('base')->model('queue');

        $queueData = array(
            'queue_title'=>'外部运单号导入',
            'start_time'=>time(),
            'params'=>array(
                'sdfdata'=>$this->import_data,
                'app' => 'wms',
                'mdl' => 'delivery_outerlogi',
            ),
            'worker'=>'wms_mdl_delivery_outerlogi.import_run',
        );
        $oQueue->save($queueData);

        $oQueue->flush();
    }

    public function import_run($cursor_id,$params,$errormsg)
    {
        $now = time();
        $opObj = app::get('ome')->model('operation_log');

        $dlyCheckLib = kernel::single('wms_delivery_check');
        $dlyProcessLib = kernel::single('wms_delivery_process');

        $deliveryObj = &app::get('wms')->model('delivery');
        $deliveryBillObj = &app::get('wms')->model('delivery_bill');

        foreach ($params['sdfdata'] as $key=>$value) {
            //$transaction = $this->db->beginTransaction();

            $opInfo = $value['opInfo']; unset($value['opInfo']);
            $is_super = $value['is_super']; unset($value['is_super']);
            kernel::single('desktop_user')->user_data = $value['user_data']; unset($value['user_data']);
            kernel::single('desktop_user')->user_id = $opInfo['op_id'];

            $dlyInfo = $deliveryObj->dump($value['delivery_id'],'print_status,process_status,branch_id,outer_delivery_bn,logi_id,logi_name,memo');
            if($dlyInfo['print_status'] > 0){
                if (($dlyInfo['print_status'] & 1) != 1) {
                    $opObj->write_log('delivery_stock@wms', $value['delivery_id'], '备货单打印(系统模拟打印)',$now,$opInfo);
                }
                if (($dlyInfo['print_status'] & 2) != 2) {
                    $opObj->write_log('delivery_deliv@wms', $value['delivery_id'], '发货单打印(系统模拟打印)',$now,$opInfo);
                }
                if (($dlyInfo['print_status'] & 4) != 4) {
                    $opObj->write_log('delivery_expre@wms', $value['delivery_id'], '快递单打印(系统模拟打印)',$now,$opInfo);
                }
            }

            $value['print_status'] = 7;
            $value['process_status'] = (($dlyInfo['process_status'] == 3) ? 3 : 1);

            //更新打印及物流重量等信息
            $result = $deliveryObj->save($value);
            if ($result) {
                //同步打印状态到oms
                $wms_id = kernel::single('ome_branch')->getWmsIdById($dlyInfo['branch_id']);
                $data = array(
                	'delivery_bn' => $dlyInfo['outer_delivery_bn'],
                );
                $res = kernel::single('wms_event_trigger_delivery')->doPrint($wms_id, $data, true);

                //保存物流单号
                $deliveryBillObj->update(array('logi_no'=>$value['logi_no']),array('delivery_id' => $value['delivery_id'],'type'=>1));

                $opObj->write_log('delivery_modify@wms', $value['delivery_id'], '修改发货单详情');

                //信息变更更新到oms
                $data = array(
                	'delivery_bn' => $dlyInfo['outer_delivery_bn'],
                    'weight' => $value['weight'],
                    'delivery_cost_actual' => $value['delivery_cost_actual'],
                    'logi_id' => $dlyInfo['logi_id'],
                    'logi_no' => $value['logi_no'],
                    'logi_name' => $dlyInfo['logi_name'],
                    'memo' => $dlyInfo['memo'],
                    'action' => 'updateDetail',
                );
                $res = kernel::single('wms_event_trigger_delivery')->doUpdate($wms_id, $data, true);

                if ($is_super) {
                    $branches = array('_ALL_');
                } else {
                    $branches = $this->getBranchByOp($opInfo['op_id']);
                }

                $process = false;

                # 校验
                if (($value['process_status'] &  2) != 2) {
                    $delivery = $dlyCheckLib->checkAllow($value['logi_no'], $msg);
                    if ($delivery === false) {
                        //$this->db->rollback();
                        continue;
                    }

                    $verify = $dlyProcessLib->verifyDelivery($value['delivery_id']);
                    if (!$verify) {
                        //$this->db->rollback();
                        continue;
                    }
                }

                # 发货
                $return_error = $dlyCheckLib->consignAllow('', $value['logi_no'], $value['weight']);
                if ($return_error) {
                    //$this->db->rollback();
                    continue;
                }

                $data = array(
    				'status'=> 1,
    				'weight'=> $value['weight'],
    				'delivery_cost_actual'=> $value['delivery_cost_actual'],
    				'delivery_time'=>time(),
                );
                $filter = array('delivery_id'=>$value['delivery_id'],'status'=> 0, 'type'=>1);
                $deliveryBillObj->update($data,$filter);

                $numdata = array('delivery_logi_number'=>1);
                $numfilter = array('delivery_id'=>$value['delivery_id']);
                $deliveryObj->update($numdata,$numfilter);

                $result = $dlyProcessLib->consignDelivery($value['delivery_id']);
                if (!$result) {
                    //$this->db->rollback();
                    continue;
                }

                //$this->db->commit($transaction);
            } else {
                //$this->db->rollback();
            }
        }

        return false;
    }

    public function getBranchByOp($op_id)
    {
        $bps = array();
        $oBops = app::get('ome')->model('branch_ops');
        $bops_list = $oBops->getList('branch_id', array('op_id' => $op_id), 0, -1);
        if ($bops_list){
            $bps = array_map('current',$bops_list);
        }

        return $bps;
    }
}
